/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.module.TestCasePickerWidget");//$NON-NLS-1$
dojo.require("com.ibm.rqm.planning.web.ui.internal.module.TestPlanPickerWidget");

(function(){
    var TEST_CASE_SERVICE_URI = "com.ibm.rqm.planning.common.service.rest.ITestCaseRestService";//$NON-NLS-1$
    var TEST_CASE_SERVICE_METHOD = "getTestCasesDTO";//$NON-NLS-1$
    var TEST_CASE_ITEM_URL = "/jazz/secure/service/com.ibm.rqm.integration.service.IIntegrationService/testcase/";//$NON-NLS-1$
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.TestCasePickerWidget", [com.ibm.rqm.planning.web.ui.internal.module.TestPlanPickerWidget], {
    	
        getServiceUri: function(){
            return TEST_CASE_SERVICE_URI;
        },
        
        getServiceMethod: function(){
            return TEST_CASE_SERVICE_METHOD;
        },
        
        getItemUrl: function(id){
            return location.protocol + '//' + location.host + TEST_CASE_ITEM_URL + "urn:com.ibm.rqm:testcase:" + id;
        }
    });
})();
