/**************************ELB************************************************* 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojo.parser");
dojo.require("dijit._TimePicker");
dojo.require("dijit.form._DateTimeTextBox");
dojo.require("dojox.collections.ArrayList");
dojo.require("jazz.app.ResourceLink");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPoints");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.DefectTableView");
//RTC Integration
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");

(function() { // module container
var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ExecutionResultClient			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var CommonImageCache 				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var PlanningUtility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ExecutionResultStateClient		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var COL_ID							= "detail_td_id_";
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var DEFECT_URL                  	= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var ViewHeaderLayout 				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var YesNoDialog      				= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var DefectTableView					= com.ibm.rqm.execution.web.ui.internal.view.table.DefectTableView;
var EWIMapper						= com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var AssetUriUtil 					= com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var ChangeRequestManager			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var Status							= com.ibm.team.repository.web.foundation.Status;
var ArrayList						= dojox.collections.ArrayList;
var CmIntegrationClient				= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;
var DEFECT_ORIGIN_1					= "ExecutionResult";
var DEFECT_ORIGIN_2					= "ScriptlessResult";

dojo.declare(
	"ExecutionLogBody._TimePicker",
	dijit._TimePicker,
	{
		_showText: function(){
			this.timeMenu.innerHTML = "";
			var fromIso = dojo.date.stamp.fromISOString;
			this._clickableIncrementDate=fromIso(this.clickableIncrement);
			this._visibleIncrementDate=fromIso(this.visibleIncrement);
			this._visibleRangeDate=fromIso(this.visibleRange);
			// get the value of the increments and the range in seconds (since 00:00:00) to find out how many divs to create
			var sinceMidnight = function(/*Date*/ date){
				return date.getHours() * 60 * 60 + date.getMinutes() * 60 + date.getSeconds();
			};
			var clickableIncrementSeconds = sinceMidnight(this._clickableIncrementDate);
			var visibleIncrementSeconds = sinceMidnight(this._visibleIncrementDate);
			var visibleRangeSeconds = sinceMidnight(this._visibleRangeDate);

			// round reference date to previous visible increment
			var time = this.value.getTime();
			this._refDate = new Date(time - time % (visibleIncrementSeconds*1000));
			/* 
			 * Need to comment out the setting of the year to 1970 since we want the date and time both to be shown
			 * and instead use the year,month and day from the this.value --- Pratik
			 */
			//this._refDate.setFullYear(1970,0,1); // match parse defaults
			this._refDate.setFullYear(this.value.getFullYear(),this.value.getMonth(),this.value.getDate()); // match parse defaults
			
			// assume clickable increment is the smallest unit
			this._clickableIncrement = 1;
			// divide the visible range by the clickable increment to get the number of divs to create
			// example: 10:00:00/00:15:00 -> display 40 divs
			this._totalIncrements = visibleRangeSeconds / clickableIncrementSeconds;
			// divide the visible increments by the clickable increments to get how often to display the time inline
			// example: 01:00:00/00:15:00 -> display the time every 4 divs
			this._visibleIncrement = visibleIncrementSeconds / clickableIncrementSeconds;
			// divide the number of seconds in a day by the clickable increment in seconds to get the
			// absolute max number of increments.
			this._maxIncrement = (60 * 60 * 24) / clickableIncrementSeconds;

			// find the nodes we should display based on our filter
			var before = this._getFilteredNodes(0, this._totalIncrements >> 1, true);
			var after = this._getFilteredNodes(0, this._totalIncrements >> 1, false);
			if(before.length < this._totalIncrements >> 1){
				before = before.slice(before.length / 2);
				after = after.slice(0, after.length / 2);
			}
			dojo.forEach(before.concat(after), function(n){this.timeMenu.appendChild(n);}, this);
		}		
	}
);
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody",
    [dijit._Widget, dijit._Templated,
     com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ExecutionLogBody.html"),
		
		widgetsInTemplate:true,
		_updatedDPUsage: false,
		labelLocalComputer: Constants.getMessage("labelLocalComputer"),
		
        constructor: function() {
            this._editorRegistry = dojo.getObject(Constants.EDITOR_REGISTRY_OBJECT_ID);
            this.relatedDefects = [];
        },
				
		postCreate: function() {
			this.VERDICT_ID = this.id+"verdictCombo";
			this.IMG_ID = this.id +"verdictimage"; 
			this.PHASE_ID = this.id+"phase";
			this.TESTCASE_ID = this.id+"testCase";
			this.TESTSCRIPT_ID = this.id+"testScript";
			this.TOTALTIME_ID = this.id+"totalTime";
            this.isNew = true;
			this._isArchived = false;
			this.defectList = [];	
			this.defectIdList = [];
			this.removedDefectIdList = [];
			this.blockedDefectIds = [];
			this.removedBlockedDefectIds = [];
			this.extERRelatedDefects = new ArrayList();
			this.extAddedERRelatedDefects = new ArrayList();
			this.extRemovedERRelatedDefects = new ArrayList();
			this.extBlockingDefects = new ArrayList();
			this.extBlockingChangedDefects = new ArrayList();
			this.isExtSaved = false;
            this._createHeader(Constants.getMessage("labelExeResult"));
            this._header.setProgressStart(Constants.getMessage("labelLoading"), /*hideContent*/true);
			if(!this.editable){
				var responseHandler = new ServiceResponseHandler(this, "_setTestScript", "_loadError");
				ExecutionResultClient.getExecutionResultDTO(responseHandler, {resultItemId: this.resultItemId, resolveDefects: true});
			}else{
				var responseHandler = new EWIMapper(this, "_setEWI", "_loadError");			
				ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, {id: this.ewiId, resolveResults: false});
			}
            this._relatedDefectInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel();
            this._relatedDefectInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"), true);
		},
		
        getStaticRelatedInfo: function() {
            return this._relatedDefectInfo;
        },
        
        getStaticRelatedInfoId: function() {
            if (this.ewi && this.ewi.id){
                return this.declaredClass + this.ewi.id;
            } else {
                var date = new Date();
                return this.declaredClass + date.toString();
            }
        },
        
        _addRelatedInfo: function() {            
            if (this.ewi) {
                var responseHandler = new ServiceResponseHandler(this, "_addrelatedDefectsInfo", "_error");
				ExecutionWorkItemClient.getRelatedDefects(responseHandler, {uuid_ewi: this.ewi.itemId, ewiStateId: this.ewi.stateId});
			}
        },
        
        _addrelatedDefectsInfo: function(relatedDefects) {
            if(!relatedDefects) {
                return;
            } 
            var group = this._relatedDefectInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"));
            dojox.data.dom.removeChildren(group._actionListNode);

            // combine defects from same test scripts and same test case and remove duplicates
            var allRelatedDefects = {};
            var defects = [];
            this.relatedDefects = [];
            if (relatedDefects.defectsByTestScript && dojo.isArray(relatedDefects.defectsByTestScript)) {
//console.debug(relatedDefects.defectsByTestScript.length + " defects by test script");
                for (var j = 0; j < relatedDefects.defectsByTestScript.length; j++) {
                    var workitemId = relatedDefects.defectsByTestScript[j].workItem.itemId;
                    allRelatedDefects[workitemId] = relatedDefects.defectsByTestScript[j];
                }
            }
            if (relatedDefects.defectsByTestCase && dojo.isArray(relatedDefects.defectsByTestCase)) {
//console.debug(relatedDefects.defectsByTestCase.length + " defects by test case");
                for (var k = 0; k < relatedDefects.defectsByTestCase.length; k++) {
                    var workitemId = relatedDefects.defectsByTestCase[k].workItem.itemId;
                    allRelatedDefects[workitemId] = relatedDefects.defectsByTestCase[k];
                }
            }
            for (var key in allRelatedDefects) {
                defects.push(allRelatedDefects[key]);
            }

            // limit the number of display items
            var length = defects.length;
            if (length > Constants.MAX_INFO_PANEL_DEFECTS) 
                length = Constants.MAX_INFO_PANEL_DEFECTS;
            for (var i = 0; i < length; i++) {
				// extract the attributes needed
				var defectAttr = defects[i].workItem.attributes;
				var id = null;
				var summary = null;
				var state = null;
				for (var j = 0; j < defectAttr.length; j++) {
					switch (defectAttr[j].key) {
						case "id":
							id = defectAttr[j].value.id;
							break;
						case "summary":
							summary = defectAttr[j].value.content;
							break;
						case "internalState":
							state = defectAttr[j].value.label;
							break;
					}
					if (id && summary && state) {
						// break out if we get all attributes that we need
						break;
					}
				}

                // skip the defect if it is already added to the execution
				if (this.defectList && dojo.isArray(this.defectList)) {
					var skipAlreadyAdded = false;
					for (var k = 0; k < this.defectList.length; k++) {
						if (this.defectList[k].id == id) {
							skipAlreadyAdded = true;
							break;
						}
					}
					if (skipAlreadyAdded) {
//console.debug("Skip added defect " + id);
						continue;
					}
				}
				
				// add defect to the related defects panel
				this.relatedDefects.push(defects[i]);
				var defectText = "";
				if (summary.length > 20) 
					defectText = id + " : " + summary.substr(0, 15) + "... - " + state;
				else 
					defectText = id + " : " + summary + " - " + state;
				var defectUrl = DEFECT_URL + id;
				this._relatedDefectInfo.addLink(Constants.getMessage("labelRelatedDefects"), defectText, defectUrl);
			}
        },  
		
		_addRelatedExternalInfo: function(){
            if (this.ewi) {
                CmIntegrationClient.getReferencedDefects({ewiItemId: this.ewi.itemId}, dojo.hitch(this, function(status, result){
					if(status.isOK()){
						this._addRelatedExternalDefectsInfo(result);
					}else{
						this._getRelatedDefectsError(result);
					}
				}));
            }
		},
		
		_addRelatedExternalDefectsInfo: function(relatedDefectsArray){
			var group = this._relatedDefectInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"));
            dojox.data.dom.removeChildren(group._actionListNode);
            if(!relatedDefectsArray) {
                return;
            }

            // combine defects from same test scripts and same test case and remove duplicates
            var allRelatedDefects = {};
            var defects = [];
            this.relatedDefects = [];

			for (var i = 0; i < relatedDefectsArray.length; i++) {
				allRelatedDefects[relatedDefectsArray[i].uri] = relatedDefectsArray[i];
			}
            for (var key in allRelatedDefects) {
				defects.push(allRelatedDefects[key]);
			}

            // limit the number of display items
            var length = defects.length;
            if (length > Constants.MAX_INFO_PANEL_DEFECTS) 
                length = Constants.MAX_INFO_PANEL_DEFECTS;
            for (var i = 0; i < length; i++) {
                // skip the defect if it is already one of the blocking defects
                if (this.blockingDefects && dojo.isArray(this.blockingDefects)) {
                    var skipAlreadyAdded = false;
                    for (var k = 0; k < this.blockingDefects.length; k++) {
                        if (this.blockingDefects[k].id == defects[i].id) {
                            skipAlreadyAdded = true;
                            break;
                        }
                    }
                    if (skipAlreadyAdded) {
                        continue;
                    }
                }
				
                // add defect to the related defects panel
                this.relatedDefects.push(defects[i]);
				var link = this._relatedDefectInfo.addLink(Constants.getMessage("labelRelatedDefects"), defects[i].id, defects[i].uri, null, true);
				var resourceLinkArgs= { 
						uri: defects[i].uri,
						presentationUri: defects[i].uri,
						label: ""
					};
				new jazz.app.ResourceLink(resourceLinkArgs, link);
            }
		},   
        
		_setTestScript: function(result){
			if(!result){
				com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(Constants.getMessage("labelExeResult"), Constants.getMessage("errRetrieveER"));
				dojox.data.dom.removeChildren(this.domNode);
				return;
			}
			this.result = result;
			this.testScript = result.script;
			if(this.ewiId){
				var responseHandler = new EWIMapper(this, "_setEWI", "_loadError");
				ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, {id: this.ewiId, resolveResults: false, includeArchived: true});
			}else{
				var responseHandler = new EWIMapper(this, "_setEWI", "_loadError");			
				ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, {resultItemId: this.result.itemId, resolveResults: false, includeArchived: true});
			}
		},
		
		_setEWI: function(ewis){
			if (this.editable) 
				this._updateHeader(Constants.getMessage("labelExeResult"), Constants.getMessage("labelScriptless"));
			else {
				var type = null
				if(this.result && this.result.script)
					type = this.result.script.scriptType.name == "Manual" ? Constants.getMessage("labelManual"):Constants.getExtensionDisplayMessage(this.result.script.scriptType.name);
				this._updateHeader(Constants.getMessage("labelExeResult"), type? type : Constants.getMessage("labelScriptless"));
			}

			//Do another asyn call to get verdict types
			if(!this.ewi && (!ewis || ewis.length > 1)){
				//this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,Constants.getMessage("errRetrieveEWI"));
				com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(Constants.getMessage("labelEWI"), Constants.getMessage("errRetrieveEWI"));
				dojox.data.dom.removeChildren(this.domNode);
                return;
			}
			var registryResponseHandler = new ServiceResponseHandler(this, "_setResultStates", "_error");
			ExecutionResultStateClient.getExecutionResultStates(registryResponseHandler, {});
			if(ewis && ewis.length)
				this.ewi = ewis[0];//Should return only one in array
			var args={
					parentController: this.parentController,
					ewi: this.ewi,
					showEnvDetails: true	//Since we need to see the name and description in ERs
			};
			if(this._scriptName)
				args.tsName = this._scriptName;
			if(this.ewi.testCase != null)
				this._testcase = this.ewi.testCase.name;
				
			dojox.data.dom.removeChildren(this._envWidget);
			var envWidget=new com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer(args);
			var params ={
				title: Constants.getMessage("labelTestEnvironment"),
				summary: envWidget.domNode,
				helpContextId: "rqm_execution_environments_help.html"
			};
			var envSection = this._createCollapsibleSection(params);
			this._envWidget.appendChild(envSection.domNode);
			var pointsArgs = {maxPoints: this.result?this.result.weight:this.ewi.weight};
			pointsArgs.callback = dojo.hitch(this,"_pointsChangedCallback");
			if(!this._isPermitted())
                pointsArgs.isDisabled = true;
			if(this.result){
				pointsArgs.pointsPassed = this.result.pointsPassed;
				pointsArgs.pointsFailed = this.result.pointsFailed;
				pointsArgs.pointsBlocked = this.result.pointsBlocked;
				pointsArgs.pointsInconclusive = this.result.pointsInconclusive;
				pointsArgs.pointsAttempted = this.result.pointsAttempted;
			}
			dojox.data.dom.removeChildren(this._pointsContainer);
			this.pointsContainer = new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPoints(pointsArgs);
			var weightparams ={
				title: Constants.getMessage("labelWeightDist"),
				summary: this.pointsContainer.domNode,
				helpContextId: "rqm_execution_weight_help.html"
			}
			var weightSection = this._createCollapsibleSection(weightparams);
			this._pointsContainer.appendChild(weightSection.domNode);
			if(this.editable)
				this._makeViewEditable();
			else
				this._fillDetails();
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", "ewiresult-icon-16", this.dirty]);
			if(!this.editable)
				this._setDirty(false);
			this.createDefectTable();
			if(ChangeRequestManager.INIT_INITIALIZED){
				this._addRelatedExternalInfo();
			} else {
				this._addRelatedInfo();
			}
		},
		
		_fillLabels: function(editable){
			if(editable){
				this.verdict0.innerHTML = Constants.getMessage("labelOverallVerdict")+Constants.getMessage("labelColen");
				this.hostName0.innerHTML = Constants.getMessage("labelHostname")+Constants.getMessage("labelColen");
				this.owner0.innerHTML = Constants.getMessage("labelOwner")+Constants.getMessage("labelColen");
				this.phase0.innerHTML = Constants.getMessage("labelIteration")+Constants.getMessage("labelColen");
				this.phase3.innerHTML = Constants.getMessage("labelStartTime")+Constants.getMessage("labelColen");
				this.testCase0.innerHTML = Constants.getMessage("labelTestCase")+Constants.getMessage("labelColen");
				this.testCase3.innerHTML = Constants.getMessage("labelEndTime")+Constants.getMessage("labelColen");
				this.testScript0.innerHTML = Constants.getMessage("labelTestScript")+Constants.getMessage("labelColen");
				this.testScript3.innerHTML = Constants.getMessage("labelTotalRunTime")+Constants.getMessage("labelColen");
				this.weight0.innerHTML = Constants.getMessage("labelWeight")+Constants.getMessage("labelColen");
				this._hbInputBox.value = Constants.getMessage("labelLocalComputer");
				this._hostName2SelectBox._setValueAttr(Constants.getMessage("labelLocalComputer"));
				this.build0.innerHTML = Constants.getMessage("labelBuild");
				this.build2.innerHTML = Constants.getMessage("labelUnassigned");
				this.buildUUID = null;
				var editImg = document.createElement("img");
				editImg.src = CommonImageCache.EDIT;
				editImg.alt = Constants.getMessage("labelChangeAssociatedBuild");
				editImg.title = Constants.getMessage("labelChangeAssociatedBuild");
				if(this.editBuildEvent)
					this.editBuildEvent = null;
				this.editBuildEvent = dojo.connect(editImg, "onclick", this, "onBuildChangeClick");
				var clearImg = document.createElement("img");
				clearImg.alt = Constants.getMessage("labelClearAssociatedBuild");
				clearImg.title = Constants.getMessage("labelClearAssociatedBuild");
				clearImg.src = CommonImageCache.CLEAR_FILTER_ENABLED;
				if(this.clearBuildEvent)
					this.clearBuildEvent = null;
				this.clearBuildEvent = dojo.connect(clearImg, "onclick", this, "onBuildClearClick");
				dojox.data.dom.removeChildren(this.build22);
				this.build22.appendChild(editImg);
				this.build22.appendChild(clearImg);
			}else{
				this._editVerdict.innerHTML = Constants.getMessage("labelOverallVerdict")+Constants.getMessage("labelColen");
				this._editHost.innerHTML = Constants.getMessage("labelHostname")+Constants.getMessage("labelColen");
				this._editOwner.innerHTML = Constants.getMessage("labelOwner")+Constants.getMessage("labelColen");
				this._editIteration.innerHTML = Constants.getMessage("labelIteration")+Constants.getMessage("labelColen");
				this._startTimeLabel.innerHTML = Constants.getMessage("labelStartTime")+Constants.getMessage("labelColen");
				this._editTestCase.innerHTML = Constants.getMessage("labelTestCase")+Constants.getMessage("labelColen");
				this._stopTimeLabel.innerHTML = Constants.getMessage("labelEndTime")+Constants.getMessage("labelColen");
				this._editTestScript.innerHTML = Constants.getMessage("labelTestScript")+Constants.getMessage("labelColen");
				this._editDatapool.innerHTML = Constants.getMessage("labelTestDataLabel");
				this._datapoolValue.innerHTML = Constants.getMessage("labelUnassigned");
				this._totalTimeLabel.innerHTML = Constants.getMessage("labelTotalRunTime")+Constants.getMessage("labelColen");
				this._editWeight.innerHTML = Constants.getMessage("labelWeight")+Constants.getMessage("labelColen");
				this._editBuild.innerHTML = Constants.getMessage("labelBuild");
				this._buildValue.innerHTML = this.result.buildRecord ? 
												(this.result.buildRecord.parentBuildDefName ? 
														this.result.buildRecord.parentBuildDefName +  " : " + this.result.buildRecord.name : 
														this.result.buildRecord.name) : 
												Constants.getMessage("labelUnassigned");
				this.buildUUID = this.result.buildRecord ? this.result.buildRecord.itemId : null; 
				if(this.editBuildEvent)
					this.editBuildEvent = null;
				if(this.clearBuildEvent)
					this.clearBuildEvent = null;
				var editImg = document.createElement("img");
				editImg.src = CommonImageCache.EDIT;
				editImg.alt = Constants.getMessage("labelChangeAssociatedBuild");
				editImg.title = Constants.getMessage("labelChangeAssociatedBuild");
				this.editBuildEvent = dojo.connect(editImg, "onclick", this, "onBuildChangeClick");
				var clearImg = document.createElement("img");
				clearImg.src = CommonImageCache.CLEAR_FILTER_ENABLED;
				clearImg.alt = Constants.getMessage("labelClearAssociatedBuild");
				clearImg.title = Constants.getMessage("labelClearAssociatedBuild");
				if(this.result.buildRecord)
					this._buildLink.href = com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil.getBuildRecordURI(this.result.buildRecord.id)
				else
					this._buildLink.href = "#";	 
				this.clearBuildEvent = dojo.connect(clearImg, "onclick", this, "onBuildClearClick");
				dojox.data.dom.removeChildren(this._changeBuildNode);
				this._changeBuildNode.appendChild(editImg);
				this._changeBuildNode.appendChild(clearImg);
			}
		},
		
		onBuildChangeClick: function(){
			 var dialogArgs = {
		            okCallback: dojo.hitch(this, "_buildSelected"),
		            cancelCallback: dojo.hitch(this, "_cancelled"),
					isClosable: true
		        };
			this.buildRecordTableView = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList({consoleNode: false, rowCheckable: true, singleSelectable: false});
			var buildSelectionDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			buildSelectionDialog.contentContainer.appendChild(this.buildRecordTableView.domNode);
			buildSelectionDialog.setWidth("80%");
	        buildSelectionDialog.setHeight("80%");
			buildSelectionDialog.setSecondaryTitle(Constants.getMessage("labelAvailableBuilds"));
			buildSelectionDialog.getOkButton().disabled = false;
			buildSelectionDialog.open();
		},
		
		_buildSelected: function(){
			var items = this.buildRecordTableView.getSelectedBuildRecord();
			if(items && items.length == 1){
				this._buildValue.innerHTML = (items[0].parentBuildDefName ? items[0].parentBuildDefName +  " : " + items[0].name: items[0].name);
				this.buildUUID = items[0].itemId;
				this._buildLink.href = com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil.getBuildRecordURI(items[0].id)
				this._setDirty(true);
			}
		},
		
		_cancelled: function(){
		},
		
		onBuildClearClick: function(){
			this._buildValue.innerHTML = Constants.getMessage("labelUnassigned");
			this.buildUUID = null;
			this._buildLink.href = "#";
			this._setDirty(true);
		},

		
		showDatapoolUsage: function(datapool){
			this._datapoolValue.innerHTML = datapool.name;
			this._datapoolLink.href = PlanningUtility.getViewDatapoolURI(datapool.itemId);
			this._updatedDPUsage = true;
		},
		
		isDatapoolValueUpdated: function(){
			return this._updatedDPUsage;
		},
		
		_fillDetails: function(){
			this._fillLabels(false);
			dojo.style(this._detailsTable, "display", "inline");
			dojo.style(this._editableTable, "display", "none");
			dojox.data.dom.removeChildren(this.phase4);
			dojox.data.dom.removeChildren(this.testCase4);
			
			this._verdict =  this.result.state.name;
			
			var image = this._getImage(Utility.getImageForState(this.result.state));
			image.id = this.IMG_ID;
			dojox.data.dom.removeChildren(this._verdictImage);
			this._verdictImage.appendChild(image);
				
			if(this.ewi){
				this._tcLink.href = Utility.getTestCaseURI(this.ewi.testCase.id)
				this._executeTestCaseValue.innerHTML = this.ewi.testCase.name;
				this._weight.innerHTML = this.result.weight ? this.result.weight : (this.ewi ? this.ewi.weight:0);
				this._phaseValue.innerHTML = this.result.phaseName ? this.result.phaseName: (this.ewi.phase ? this.ewi.phase.name : "");
			}	
			else
				this._executeTestCaseValue.innerHTML = "";	
			this._TestScriptValue.innerHTML = this.result.script? this.result.script.name:"";
			
			if (this.result.script && this.result.script.snapshotInfo) {
				this._tsLink.href = Utility.getTestScriptURI(this.result.script.versionableItemId, null, 
							this.result.script.snapshotInfo.revision, this.result.script.snapshotInfo.name);
			} else {	
				this._tsLink.href = this.result.script ? Utility.getTestScriptURI(this.result.script.id, Utility.CONSTRUCTION_PERSPECTIVE) : "";
			}
			this._setVerdictValue();
			if(!this._isPermitted()){ //Check for permissions before showing the combo
                dojo.style(this._verdictValue, "display", "inline");
                dojo.style(this.verdictValueCombo, "display", "none");
			}
			this._owner.innerHTML = this.result.owner ? this.result.owner.name : "";
			this._startTimeValue.innerHTML = Utility._convertLongToDate(this.result.startTime);
			if(this.result.endTime>0)
				this._stopTimeValue.innerHTML = Utility._convertLongToDate(this.result.endTime);
			else
				this._stopTimeValue.innerHTML = Constants.getMessage("labelNA");
			var hostNameLabel = document.createElement('label');
			
			hostNameLabel.innerHTML = this.result.machine;
			dojox.data.dom.removeChildren(this._hostNameDiv);
			if(this.result.machineItemId){
				var anchorTag = document.createElement('a');
				anchorTag.className = "link";
				anchorTag.href = AssetUriUtil.getViewAssetDetailURI( "Machine", this.result.machineItemId);
				hostNameLabel.className = "value-label link";
				anchorTag.appendChild(hostNameLabel);
				this._hostNameDiv.appendChild(anchorTag);
			}else{
				hostNameLabel.className = "value-label";
				this._hostNameDiv.appendChild(hostNameLabel);
			}
				
			if(this.result.endTime && this.result.startTime){
				var duration = this.result.endTime - this.result.startTime;
				var testDuration = this._getTimeDifferenceInHrMinSec(duration);
				this._totalTimeValue.innerHTML = testDuration;
			}
			this._initTypeSpecificSection();
		},
		
		_setVerdictValue:function(){
			this._verdictValue.innerHTML = this.result.state.name;
			dojo.style(this._verdictValue,"display","none");
		},
		_createCollapsibleSection: function(args){
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? Constants.getExtensionDisplayMessage(args.title) : "");
	        expando.infoNode.innerHTML = args.info ? Constants.getExtensionDisplayMessage(args.info) : "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.setCSHelpId(args.helpContextId);
			expando.setCSHelpButtonLabel(Constants.getMessage("labelCSHelp"), args.title ? Constants.getExtensionDisplayMessage(args.title) : "");
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},
		
		_makeViewEditable: function(){
			this._fillLabels(true);
			this._makeEditableSection();
			this._initTypeSpecificSection();
		},
		
		_makeEditableSection: function(){
			dojo.style(this._detailsTable, "display", "none");
			//Verdict Row
			var image = this._getImage(ImageCache.PASS_ICON);
			if(this.verdicts)
				image = this._getImage(Utility.getImageForState(this.verdicts[0].id));
			image.id = this.IMG_ID;
			dojox.data.dom.removeChildren(this.verdict1);
			this.verdict1.appendChild(image);
			//Owner
			this.owner2.appendChild(this._getLabel( getAuthenticatedContributor().name));
			//Phase and StartTime
			dojox.data.dom.removeChildren(this.phase2);
			var name = this.ewi.phase? this.ewi.phase.name : Constants.getMessage("labelNotFound");
			this.phase2.appendChild(this._getCombo({id: this.PHASE_ID, options: [{name: name, id: name} ]}));
			var startDate = new Date();
			var elbSelf = this;
			var dateNode = document.createElement('div');
			this.startTimeNode = new dijit.form._DateTimeTextBox({
				onChange: elbSelf._updateTotalRunTime ,
				callback: elbSelf,
				_selector:"datetime",
				popupClass: "ExecutionLogBody._TimePicker"
			});
			this.startTimeNode._setValueAttr(startDate);
			dojo.removeClass(this.startTimeNode,"dijitTimeTextBox");
			dojox.data.dom.removeChildren(this.phase4);
			this.phase4.appendChild(this.startTimeNode.domNode);
			//Test Case and EndTime
			dojox.data.dom.removeChildren(this.testCase2);
			this.testCase2.appendChild(this._getCombo({id: this.TESTCASE_ID, options: [{name: this.ewi.testCase.name, id: this.ewi.testCase.versionableItemId} ]}));
			var endDate = startDate;
			this.endTimeNode = new dijit.form._DateTimeTextBox({
				onChange: elbSelf._updateTotalRunTime,
				callback: elbSelf,
				_selector:"datetime",
				popupClass: "ExecutionLogBody._TimePicker"
			});
			this.endTimeNode._setValueAttr(startDate);
			dojo.removeClass(this.endTimeNode,"dijitTimeTextBox");
			dojox.data.dom.removeChildren(this.testCase4);
			this.testCase4.appendChild(this.endTimeNode.domNode);
			//Test Script and Total time
			dojox.data.dom.removeChildren(this.testScript2);
			this.testScript2.appendChild(this._getCombo({id: this.TESTSCRIPT_ID, options: [{name: Constants.getMessage("labelNoScriptsFound"), id: "No Script"} ]}));
			var div  =document.createElement('div');
			div.id = this.TOTALTIME_ID;
			dojox.data.dom.removeChildren(this.testScript4);
			this.testScript4.appendChild(div);
			//Weight
			dojox.data.dom.removeChildren(this.weight2);
			this.weight2.appendChild(this._getLabel( this.ewi.weight ? this.ewi.weight : 0, " "));
		},
		
		_handleHostChange: function(){
		},
		_fixYear:function(value){
			// need this method since passing a two-digit year gets converted to 1900+year by Date constructor
			var yr = value.getFullYear();
			if(yr<1950)
				yr = yr+100;
			value.setFullYear(yr);
			return value;
		},
		_updateTotalRunTime: function(){
			if(this.callback && this.callback.endTimeNode){	
				var enteredStartTime = this.callback.startTimeNode._getValueAttr() != "" ?this.callback.startTimeNode._getValueAttr() : 0;
				var enteredEndTime = this.callback.endTimeNode._getValueAttr() != "" ? this.callback.endTimeNode._getValueAttr() : 0;
				var st = new Date(enteredStartTime);
				var et = new Date(enteredEndTime);
				st = enteredStartTime ===0?st:this.callback._fixYear(st);
				et = enteredEndTime ===0?et:this.callback._fixYear(et);				
				var startTime = 0;var endTime = 0;
				var testDuration = "";
				if(!st.isNaN && !et.isNaN){
					startTime = Utility._convertDateToLong(st);
					endTime = Utility._convertDateToLong(et);
					var duration = endTime - startTime;
					if(duration <0 || startTime === 0){
						testDuration = Constants.getMessage("labelInvalidEntry");
						var rightNode = this.callback._header.getRightActionsContainer();
						var childNodes = rightNode.childNodes;
						for(var i=0;i<childNodes.length;i++){
							childNodes[i].disabled = true;
						}
						var rightBottomNode = this.callback._header.getRightActionsBottomContainer();
						var childBottomNodes = rightBottomNode ? rightBottomNode.childNodes : [];
						for(var i=0;i<childBottomNodes.length;i++){
							childBottomNodes[i].disabled = true;
						}
					}	
					else{
						var rightNode = this.callback._header.getRightActionsContainer();
						var childNodes = rightNode.childNodes;
						for(var i=0;i<childNodes.length;i++){
							childNodes[i].disabled = false;
						}
						var rightBottomNode = this.callback._header.getRightActionsBottomContainer();
						var childBottomNodes = rightBottomNode ? rightBottomNode.childNodes : [];
						for(var i=0;i<childBottomNodes.length;i++){
							childBottomNodes[i].disabled = false;
						}
						testDuration = this.callback._getTimeDifferenceInHrMinSec(duration);
					}	
				}else{
					testDuration = Constants.getMessage("labelNumberMin", 0);
				}
				var element = this.callback.testScript4;
				element.innerHTML = testDuration;
			}
		},
		
		_getTimeDifferenceInHrMinSec: function(duration){
			return Utility.getTimeDifferenceInHrMinSec(duration);
		},

		_getLabel: function(name, style){
			var label = document.createElement('label');
			label.className = style ? style : "name-label";
			label.innerHTML = name;
			return label;
		},
		
		_getCombo: function(args){
			var options = args.options;
			var combo = document.createElement('select');
			combo.style.width = '100%';
			combo.id = args.id;
			for(var i=0 ; i<options.length ; i++){
				var option = new Option(options[i].name, options[i].id ? options[i].id : options[i].name);
				SelectUtility.add( combo, option );
			}
			return combo;
		},
		
		_getImage: function(src){
			var img = document.createElement('img');
			img.src = src ? src : "";
			return img;
		},
		
		_updateVerdictIcon: function(){
			var selection = "";
			var combo = document.getElementById(this.VERDICT_ID);
			for(var i=0;i<combo.options.length; i++){
				if(combo.options[i].selected){
					selection = combo.options[i].value;
					this._verdictValue.innerHTML = combo.options[i].text;
				}	 
			}
            document.getElementById(this.IMG_ID).src = Utility.getImageForState(selection);		
			this.changedVerdict = selection;
			this._setDirty(true);
		},
		
	  /////////////////////////////////////////////////////////////////////////////////////////////////////
      //                                   PLUGGABLE SECTION SUPPORT                                   //
      ////////////////////////////////////////////////////////////////////////////////////////////////////      
      _initTypeSpecificSection: function() {
         if (!this._sectionConfig) {
            this._sectionConfig = this._editorRegistry.getEditor(this);  
         }      
         dojox.data.dom.removeChildren(this._typeSpecificSection);
         this._typeSpecificSectionWidget = this._getTypeSpecificSectionWidget();
		 if(this._typeSpecificSectionWidget == null)
		 {
		 	this._typeSpecificSectionTitle.innerHTML = "";//Dont make isDefault=true for any type of script
		 	return;
		 }
		 var helpId = "";
		 if(dojo.isFunction(this._typeSpecificSectionWidget.getHelpContextID))
		 	helpId = this._typeSpecificSectionWidget.getHelpContextID();
			
		 /* Make section collapsible */
			var params ={
				title: Constants.getMessage("labelResultDetails"),
				info: this._typeSpecificSectionConfig.name,
				summary: this._typeSpecificSectionWidget.domNode,
				helpContextId: helpId
			}
			if(this.ewi){
				var anchor = document.createElement("A");
				anchor.href = Utility.getEWIResultsURI(this.ewi.itemId);
				anchor.appendChild(document.createTextNode(Constants.getMessage("labelLinkResult")));
				anchor.className = "link";
				params.headerRight = anchor;
			}
			var section = this._createCollapsibleSection(params);
			this._typeSpecificSection.appendChild(section.domNode);  
      
			this._typeSpecificSectionWidget.initialize(); 
      },
      
      _getTypeSpecificSectionWidget: function() {
         var scriptType =  this.testScript ? this.testScript.scriptType : {id:"com.ibm.rqm.planning.common.scripttype.noscript"};
         this._typeSpecificSectionConfig = this._getTypeSectionConfig(scriptType);
         console.info("Dynamic Widget loading...ScriptType: [" + scriptType.id + "]; Widget Id: [" + this._typeSpecificSectionConfig.jsClass + "]");
         jazz.core.loader.load_sync(this._typeSpecificSectionConfig.jsClass);
         var sectionConstructor = dojo.getObject(this._typeSpecificSectionConfig.jsClass);
         var weight = this.ewi ? ( this.ewi.weight ? this.ewi.weight : 0): 0;
		 var widgetArgs = { parentController: this.parentController, 
							 parentEditor: this,
							 result: this.result,
							 weight: weight,
							 config: this._typeSpecificSectionConfig
						};
		 					
         var contributedWidget = new sectionConstructor(widgetArgs);     
         return contributedWidget;
      },
      
      _getTypeSectionConfig: function(scriptType) {
         var found = null;
         var isDefault = false;
         var sections = this._sectionConfig.sections;
         for (var i = 0; i < sections.length; i++) {
            var section = sections[i];
			var properties = section && dojo.isArray(section.properties) ? section.properties : [];
            for (var j = 0; j < properties.length; j++) {
               var attribute = properties[j];
               if (attribute.id == "com.ibm.rqm.planning.common.executionScriptType" && attribute.value == scriptType.id) {
                  return section;
               } else if (attribute.id == "default" && attribute.value == "true") {
                  found = section;
                  isDefault = true;
               }
            }
         }
         if (found != null && isDefault) {
            console.info("No widget found for ScriptType: [" + scriptType.id + "]; Using default Section: [" + found.id + "]");
         }
         return found;          
      },
	  getArtifactSection:function(){
	  	return null;
	  },
	  getArtifactType:function(){
	  	 return Constants.TYPE_EXE_LOG+"_details";
	  },

		///////////////////////////////////////////////////////////////////
	
		_setResultStates: function(verdicts){	
			this.verdicts = [];
			for(var i=0;i<verdicts.length; i++) {
				this.verdicts.push({name: verdicts[i].name, id: verdicts[i].id});
			}
			var combo = this._getCombo({id: this.VERDICT_ID, options: this.verdicts});
			if(this.editable) {
				if (this.verdict2.childNodes)
					dojox.data.dom.removeChildren(this.verdict2);
				this.verdict2.appendChild(combo);			
			} else {
				for(var i=0;i<combo.options.length; i++){
					if(this._verdictValue.innerHTML == combo.options[i].text)
						combo.options[i].selected = "selected";
				}
				if(this.verdictValueCombo.childNodes)
					dojox.data.dom.removeChildren(this.verdictValueCombo);
				this.verdictValueCombo.appendChild(combo);
			}
			dojo.addClass(combo, "verdict-value")
			dojo.connect(combo, "onchange", this, this._updateVerdictIcon);
            
            this._header.setProgressEnd();
		},

		onCancel: function(){
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					if(self._header)
						self._header.clearStatus();
					self._setEWI();
					return true;          
				},
				noCallback: function() {
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
		},
		
		onSave: function(){	
			if(this.editable){
				var hN = document.getElementById("hiddenBox");
				var hostName = hN.value;
				var enteredStartTime = this.startTimeNode._getValueAttr() != "" ? this.startTimeNode._getValueAttr() : 0;
				var enteredEndTime = this.endTimeNode._getValueAttr() != "" ? this.endTimeNode._getValueAttr() : 0;
				var st = new Date(enteredStartTime);
				var et = new Date(enteredEndTime);
				var startTime = 0;
				if(!st.isNaN)
					startTime = Utility._convertDateToLong(st);
				var endTime = 0;
				if(!et.isNaN)	
					endTime = Utility._convertDateToLong(et);
					
				var params = {
					ewiItemId: this.ewi.itemId,
					ewiStateId:this.ewi.stateId,
					newExecutionResult: true,
					state: this._getSelectedValue(this.VERDICT_ID),
					machine: hostName,
					startTime: startTime,
					endTime: endTime,
					owner:  getAuthenticatedContributor().userId,
					phase: this._getSelectedValue(this.PHASE_ID),
					testCase: this._getSelectedValue(this.TESTCASE_ID)
				}
			}else if(this.changedVerdict){
				var params = {
					workItemID: this.result.itemId,
					resultStateId:this.result.stateId,
					state: this.changedVerdict,
					startTime:this.result.startTime,
					endTime:this.result.endTime
				};
				if(this.ewi.currentResult && (this.result.itemId == this.ewi.currentResult.itemId))
					params["ewiItemId"] = this.ewi.itemId;//Update the EWI as well	
			}else{
				var params = {
					workItemID: this.result.itemId,
					resultStateId:this.result.stateId					
				};
			}
			var points = this.pointsContainer.getPoints();
			if(!points)
				return;
			else{
               for (var element in points) 
                  params[element] = points[element];
			}
			if(!this._validate(params))
				return;
			if(this._typeSpecificSectionWidget && dojo.isFunction(this._typeSpecificSectionWidget.getAttributes)){
				var abc = this._typeSpecificSectionWidget.getAttributes();
				var addAttachmentItemIds = [];
				if(abc){
					if (abc.content) {
						params.content = dojo.trim(abc.content);
					}
					var attachments = abc.attachments;
					for(var i=0;i<attachments.length;i++)
						addAttachmentItemIds.push(attachments[i].uuid);
					params.addAttachmentItemIds = addAttachmentItemIds;
				}
			}
			if(this._typeSpecificSectionWidget && this._typeSpecificSectionWidget.isLogDirty){
				if(this._typeSpecificSectionWidget.isLogDirty()){
					params = dojo.mixin(params,this._typeSpecificSectionWidget.getMixInArgs())
				}
			}
			
			params.defectIds = this.defectIdList;
			params.removeDefectIds = this.removedDefectIdList;
			if (!this.buildUUID){
				params.removeBuildLink = true;
			}
			params.buildRecordItemId = this.buildUUID;
			var responseHandler = new ServiceResponseHandler(this, "_saveComplete", "_saveError");			
	    	ExecutionResultClient.postExecutionResultDTO(responseHandler, params);
			this.setLastSaved(Constants.STATUS_SAVING);
			this.isExtSaved = true;
		},
		_validate:function(params){
			var blocking = false;
			for(var k=0;k<this.defectList.length;k++){
				if(this.defectList[k].isBlocking == true){
						blocking = true;
						break;
					}
			}
			dojo.forEach(this.extERRelatedDefects.toArray(), function(defect){
					if(defect.isBlocking == true){
						blocking = true;
					}
			});
			if(blocking && params.pointsBlocked == 0){
				this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,Constants.getMessage("msgBlockedWeightZero"));
				return false;
			}
			return true;
		},
		_saveComplete: function(resultObj){
            var artifactUri;
			if (!this.editable) {
				this._setTestScript(resultObj);
				dojo.publish(GlobalEvents.ArtifactsUpdated, [ Constants.TYPE_EXE_LOG, [ resultObj ], artifactUri ]);
			}
			else {
				this.editable = false;
				this._setTestScript(resultObj);
				artifactUri = Utility.getResultURI({ewiId: this.ewi.id, resultItemId: resultObj.itemId})
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, artifactUri]);
				dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_EXE_LOG, [resultObj], artifactUri]);
				//Enable Action buttons after saving	
				ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
	                if(currentProvider != null && this.defectTable){
						this.defectTable = null;
						this.resultItemId = this.result.itemId;
						this.createDefectTable();
						this.defectTable.enableActions();
					}
	            }));
			}
            if (this.isNew)
                this.isNew = false;
			if(this._typeSpecificSectionWidget && this._typeSpecificSectionWidget.setLogDirty){
				this._typeSpecificSectionWidget.setLogDirty(false);
			}
			//need updated EWI stateID
			if(this.blockedDefectIds.length >0 || this.removedBlockedDefectIds.length >0){
				var responseHandler = new EWIMapper(this, "_updateBlockedDefects", "_saveError");			
				ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, {id: this.ewi.id, includeArchived: true});
			}else{
				this._setDirty(false);
				this.setLastSaved(Constants.STATUS_SUCCESS);
			}
			ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
                if (currentProvider != null){
					this._associateDefect();
				}
            }));
			
			this.changedVerdict = null;
		},
		
		_associateDefect: function(){
			var extAddedERRelatedDefects = this.extAddedERRelatedDefects.toArray();
			if (extAddedERRelatedDefects.length > 0) {
				var i = 0;
				var associateDefect = dojo.hitch(this, function(monitor, currentProvider){
					var workItem = extAddedERRelatedDefects[i];
					
                    var linkDescription = {};
					linkDescription.id = workItem.id;
					linkDescription.url = workItem.defectItemUri;
                    linkDescription.linkComment = Constants.getMessage("labelRelatedER", this.result.name);
                    linkDescription.rqmUrl = this._getExecutionResultUri();
                    linkDescription.linkType = ChangeRequestManager.LINK_TYPE_AFFECT_ER;
                    
                    currentProvider.postLink(linkDescription, dojo.hitch(this, function(status, response){
//                        if (status.isOK()) {
                            console.debug("posting remote links succeed");
                            this.extAddedERRelatedDefects.remove(extAddedERRelatedDefects[i]);
							this.extERRelatedDefects.add(extAddedERRelatedDefects[i]);
							if (i < extAddedERRelatedDefects.length - 1) {
								i++;
								associateDefect(monitor, currentProvider);
							}
							else {
//								this._unassociateDefect();
//								monitor.done();
								this._postLinkToExecutionResults(extAddedERRelatedDefects, monitor);
							}
//                        }
//                        else {
//                            console.debug("posting remote links error");
//                            monitor.done();
//                        }
                    }));
				});
				ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
					ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
                        if(currentProvider != null){
							associateDefect(monitor, currentProvider);
						}
                    }));
				}));
			} else {
				this._unassociateDefect();
			}
		},
		
		_postLinkToExecutionResults: function(workItems, monitor){
			var i = 0;
			if (workItems.length > 0) {
				//Post local link to TER
				var i = 0;
				var postLinkToExecutionResult = dojo.hitch(this, function(monitor){
					if (i == workItems.length) {
						monitor.done();
						this._unassociateDefect();
						return;
					}else{
						var linkParams = {
							itemId: this.resultItemId, 
							cmUri: workItems[i].defectItemUri,
							id: workItems[i].id,
							summary: workItems[i].summary,
							linkType: CmIntegrationClient.RESULT_RELATEDTO_DEFECT
						};
						CmIntegrationClient.postNewLink(linkParams, dojo.hitch(this, function(status){
							i++;
							postLinkToExecutionResult(monitor);
		                }));
					}
				});
				postLinkToExecutionResult(monitor);
			} else {
				this._unassociateDefect();
			}
		},
		
		_unassociateDefect: function(){
			var extRemovedERRelatedDefects = this.extRemovedERRelatedDefects.toArray();
			var i = 0;
			if(this.resultItemId && extRemovedERRelatedDefects.length) { 
				var unassociateDefect = dojo.hitch(this, function(monitor, currentProvider){
					var workItem = extRemovedERRelatedDefects[i];
					
                    var linkDescription = {};
                    linkDescription.id = workItem.id;
					linkDescription.url = workItem.defectItemUri;
                    linkDescription.linkComment = Constants.getMessage("labelRelatedER", this.result.name);
                    linkDescription.rqmUrl = this._getExecutionResultUri();
                    linkDescription.linkType = ChangeRequestManager.LINK_TYPE_AFFECT_ER;
                    
                    currentProvider.deleteLink(linkDescription, dojo.hitch(this, function(status, response){
                        if (status.isOK()) {
                            console.debug("posting remote links succeed");
//                            this.extRemovedERRelatedDefects.remove(extRemovedERRelatedDefects[i]);
//							this.extERRelatedDefects.remove(extRemovedERRelatedDefects[i]);
							if (i < extRemovedERRelatedDefects.length - 1) {
								i++;
								unassociateDefect(monitor, currentProvider);
							}
							else {
								this._deleteLinkToExecutionResults(monitor);
//								monitor.done();
							}
                        }
                        else {
                            console.debug("posting remote links error");
//                            monitor.done();
                        }
                    }));
				});
				ProgressDialog.doRunWithProgress(Constants.getMessage("labelUnassociateDefect"), dojo.hitch(this, function(monitor){
					ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
                        if(currentProvider != null){
							unassociateDefect(monitor, currentProvider);
						}
                    }));
				}));
			}else {
				this._changeBlockingStatus();
			}	
		},
		
		_deleteLinkToExecutionResults: function(monitor){
			var workItems = this.extRemovedERRelatedDefects.toArray();
			if(this.resultItemId && workItems.length) {	
				var defectURIArray = [];
				dojo.forEach(workItems, dojo.hitch(this, function(workItem) {							
									if (workItem.defectItemUri)
										defectURIArray.push(workItem.defectItemUri);	
								}));
				var linkParams = {
					itemIdOrURI: this.resultItemId,
					defectURIArray: defectURIArray
				};
				CmIntegrationClient.postDeleteLink(linkParams, dojo.hitch(this, function(status){
					monitor.done();
					var extRemovedERRelatedDefects = this.extRemovedERRelatedDefects.toArray();
					dojo.forEach(extRemovedERRelatedDefects, dojo.hitch(this, function(workItem) {							
								this.extERRelatedDefects.remove(workItem);	
							}));
					this.extRemovedERRelatedDefects.clear();
					this._changeBlockingStatus();
                }));
			}else{
				this._changeBlockingStatus();
			}
			
		},
		
		_changeBlockingStatus: function(){
			var extBlockingChangedDefects = this.extBlockingChangedDefects.toArray();
			var i = 0;
			if(extBlockingChangedDefects.length > 0){
				var postParams = {
					defectURI: extBlockingChangedDefects[i].defectItemUri,
					resultItemId: this.resultItemId,
					isBlocked: extBlockingChangedDefects[i].isBlocking
				};
				var changeBlockingDefect = dojo.hitch(this, function(monitor){
		            CmIntegrationClient.postBlockDefect(postParams, dojo.hitch(this, function(status){
		                if(status.isOK()){
							if (i < extBlockingChangedDefects.length - 1) {
								i++;
								changeBlockingDefect(monitor);
							}
							else {
//								monitor.done();
								this._updateBlockingBackLink(monitor);
							}
						}
		            }));
				});
				ProgressDialog.doRunWithProgress(Constants.getMessage("labelChangeBlocking"), changeBlockingDefect);
			}
		},
		
		_updateBlockingBackLink: function(monitor){
			var extBlockingChangedDefects = this.extBlockingChangedDefects.toArray();
			var i = 0;
			if(extBlockingChangedDefects.length) { 
				var updateBlockingBackLink = dojo.hitch(this, function(monitor, currentProvider){
					var workItem = extBlockingChangedDefects[i];
					
                    var linkDescription = {};
                    linkDescription.id = workItem.id;
					linkDescription.url = workItem.defectItemUri;
                    linkDescription.linkComment = (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name);
                    linkDescription.rqmUrl = this._getEwiUri(this.ewi) + (this.testScript ? ("?runScript=" + this.testScript.versionableItemId) : "");
		            linkDescription.linkType = ChangeRequestManager.LINK_TYPE_BLOCK_ER;
					
					if(workItem.isBlocking){
						currentProvider.postLink(linkDescription, dojo.hitch(this, function(status, response){
	                        if (status.isOK()) {
	                            console.debug("posting remote links succeed");
	                            this.extBlockingDefects.add(extBlockingChangedDefects[i]);
								this.extBlockingChangedDefects.remove(extBlockingChangedDefects[i]);
								if (i < extBlockingChangedDefects.length - 1) {
									i++;
									updateBlockingBackLink(monitor, currentProvider);
								}
								else {
									monitor.done();
								}
	                        }
	                        else {
	                            console.debug("posting remote links error");
	                            monitor.done();
	                        }
	                    }));
					}else{
						currentProvider.deleteLink(linkDescription, dojo.hitch(this, function(status, response){
	                        if (status.isOK()) {
	                            console.debug("posting remote links succeed");
								this.extBlockingChangedDefects.remove(extBlockingChangedDefects[i]);
								if (i < extBlockingChangedDefects.length - 1) {
									i++;
									updateBlockingBackLink(monitor, currentProvider);
								}
								else {
									monitor.done();
								}
	                        }
	                        else {
	                            console.debug("posting remote links error");
	                            monitor.done();
	                        }
	                    }));
					}
				});
				ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
                    if(currentProvider != null){
						updateBlockingBackLink(monitor, currentProvider);
					}
                }));
			}
		},
		
		_getEwiUri: function(ewi) {
			var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
			result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
			result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + ewi.itemId;
			return result;
		},
		
		_getExecutionResultUri:function(){
			var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
			result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
			result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionResult/" + this.resultItemId;
			return result;
		},
		
		_saveError: function(status){
			if (status!=null && status.message!=null) {
				var re = /^\[(\d+)\]\s*:\s*/;
				status.message = status.message.replace(re, "");
			}
			 this.setLastSaved(Constants.STATUS_FAILURE, status);
		},
		_updateBlockedDefects:function(ewi){
			if(ewi && ewi.length > 0){
				ewi = ewi[0];
			}
			this.ewi.stateId = ewi.stateId;
			var elbSelf =this;
				var callbackObj ={
					success: function(ewi){
						elbSelf.ewi = ewi;
						elbSelf.createDefectTable();
						elbSelf._setDirty(false);
						elbSelf.blockedDefectIds=[];
						elbSelf.removedBlockedDefectIds=[];
						elbSelf.setLastSaved(Constants.STATUS_SUCCESS);
						dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI,[ewi]]);
				  	},
				  	failure: function(error){
				  		console.error("could not updateEWI with blocking defects")
				  	}
				}
				var args = {id: this.ewi.id, ewiStateId:this.ewi.stateId};
				if(this.blockedDefectIds.length >0)
					args.addDefectIds = this.blockedDefectIds;
				if(this.removedBlockedDefectIds.length >0)
					args.removeDefectIds = this.removedBlockedDefectIds;
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");			
				ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, args);
		},
		_getSelectedValue: function(id){
			var combo = document.getElementById(id);
			var selectedIndex = combo.selectedIndex;
			var value = combo.options[selectedIndex].value;
			return value;
		},
		
		_isPermitted:function(){
            if(!this.er_type)
                this.er_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_RESULT;
            if(!this.er_perm)
                this.er_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(this.er_type);
			if (this.er_perm && !this.er_perm.edit)
                return false;
            return true;

        },
        
        _updateHeader: function(title, scriptType) {
            if (this._header) {
                this._header.setTitle(title);
                this._header.setTypeLabel(Constants.getMessage("labelResultSuffix", scriptType));
            } else {
                this._createHeader(title, scriptType);
            }
        },
        
		_createHeader: function(title, scriptType) {
			if (this._header) {
                this._header.setTitle(title);
                this._header.setTypeLabel(Constants.getMessage("labelResultSuffix", scriptType));
                return this._header;
            }
            dojox.data.dom.removeChildren(this.header);
			var iconClass = "ewiresult-icon-48";
			var args = {
                title: title ? title : "",
                typeLabel: scriptType ? Constants.getMessage("labelResultSuffix", scriptType) : "",
                iconClass: iconClass,
				contextHelpId: "rqm_execution_results_overview.html",
                summary: "",
                isDisplayBottomButton: false
            }
            this._header = new ViewHeaderLayout(args);     
			this._header.setCSHelpButtonLabel(Constants.getMessage("labelExecutionResultCSHelp"));       
			this.cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"), null, null);
			this.saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);
            if(!this._isPermitted()){
                this.cancelButton.setDisabled(true);
				this.saveButton.setDisabled(true);
            }
			
            this.header.appendChild(this._header.domNode);
			return this._header;
        },
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EWI)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.ewi && (this.ewi.id == artifactArray[i].id)) {
                        this._header.setStatus(Constants.getMessage("msgEWIOfERDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SCRIPT)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.testScript && (this.testScript.id == artifactArray[i].id)) {
                        this._header.setStatus(Constants.getMessage("msgTestScriptOfERDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_CASE)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.ewi && (this.ewitestCase.id == artifactArray[i].id)) {
                        this._header.setStatus(Constants.getMessage("msgTestCaseOfERDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EXE_LOG)) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.result && (this.result.itemId == artifactArray[i].itemId)) {
                        this._header.setStatus(Constants.getMessage("msgERDeleted"), ViewHeaderLayout.ERROR);
						this._isArchived = true;
						this.saveButton.setDisabled(true);
						this.cancelButton.setDisabled(true);
                        return;
                    }
                }
            }
        },
		
        setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
                                 
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            if(st_code > -1)
               this._header.setStatus(text, st_code, detail_msg);
            else
                this._header.clearStatus();
        },
		
		_setDirty:function(dirty){
			if(!this._isArchived){
				this.dirty = dirty;
				this.saveButton.setDisabled(!dirty);
				this.cancelButton.setDisabled(!dirty);
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, dirty]);
				if(dirty)
					this.setLastSaved(Constants.STATUS_DIRTY);
			}else{
				this.dirty = false;
				this.saveButton.setDisabled(true);
				this.cancelButton.setDisabled(true);
			}
		},
		
		_pointsChangedCallback:function(){
			this._setDirty(true);
		},
		
		isDirty:function(){
			return this.dirty;
		},
		_updateDefectStatus:function(defectId,blocking,dontUpdate){
			for(var i=0;i<this.removedBlockedDefectIds.length;i++){
				if(defectId == this.removedBlockedDefectIds[i]){
					this.removedBlockedDefectIds.splice(i,1);
					break;
				}
			}
			for(var j=0;j<this.blockedDefectIds.length;j++){
				if(defectId == this.blockedDefectIds[j]){
					this.blockedDefectIds.splice(j,1);
					break;
				}
			}
			if(blocking)
				this.blockedDefectIds.push(defectId);				
			else
				this.removedBlockedDefectIds.push(defectId);
			if (!dontUpdate) {
				for (var k = 0; k < this.defectList.length; k++) {
					if (this.defectList[k].id == defectId) {
						if (blocking) 
							this.defectList[k].isBlocking = true;
						else 
							this.defectList[k].isBlocking = false;
						break;
					}
				}
			}
			this.updateDefectSection();
			this._setDirty(true);
		},
		_updateExtDefectStatus:function(defects){
			dojo.forEach(defects, dojo.hitch(this, function(defect){
				defect.isBlocking = !defect.isBlocking;
				var exist = false; 
				this.extBlockingChangedDefects.forEach(function(item){
					if(item.id == defect.id){
						exist = true;
					}
				},this);
				if(!exist){
					this.extBlockingChangedDefects.add(defect);
				}
			}));

			this.updateDefectSection();
			this._setDirty(true);
		},
		_appendInDefectList: function(data,type){
			if(data && data.length>0){
				this.setBlockingStatus(data);
				for(var i=0;i<data.length;i++){
					var foundinDefectList = false;
					for(var k=0;k<this.defectList.length;k++){
						if(this.defectList[k].id == data[i].id){
							foundinDefectList = true;
							break;
						}
					}
					if(!foundinDefectList) {
						this.defectList.push(data[i]);
						this.defectIdList.push(data[i].id);
						if (type == "new") {
							this._header.setStatus(Constants.getMessage("msgNewDefectAddedtoER", data[i].id), 
								ViewHeaderLayout.INFO, Constants.getMessage("msgDefectCanBeViewed"));
						}
						else {
							this._header.setStatus(Constants.getMessage("msgDefectAddedtoER", data[i].id), 
								ViewHeaderLayout.INFO, Constants.getMessage("msgDefectCanBeViewed"));
						}					
					}
				}
				this.updateDefectSection();
				this._setDirty(true);
			}
		},
		_removeDefects:function(defects){
			if(this._typeSpecificSectionWidget && this._typeSpecificSectionWidget.deleteDefect){
				this._typeSpecificSectionWidget.deleteDefect(defects);
			}else
				this._deleteDefects(defects);
		},
		_deleteDefects:function(defects){
			if(defects && defects.length){
				for(var j=0;j<defects.length;j++){
					if(this.defectList && this.defectList.length){
						for(var i=0;i<this.defectList.length;i++){
							if(this.defectList[i].id == defects[j].id ){
								this.defectList.splice(i,1);
								break;
							}
						}
					}
					if(this.defectIdList && this.defectIdList.length){
						for(var i=0;i<this.defectIdList.length;i++){
							if(this.defectIdList[i] == defects[j].id ){
								this.defectIdList.splice(i,1);
								var alreadyInRemoveList = false;
								for(var k=0;k<this.removedDefectIdList.length;k++){
									if(this.removedDefectIdList[k] == defects[j].id){
										alreadyInRemoveList = true;
										break;
									}
								}
								if(!alreadyInRemoveList)
									this.removedDefectIdList.push(defects[j].id);
								break;
							}
						}
					}
					this._updateDefectStatus(defects[j].id,false,true);
				}
				this.updateDefectSection();
				this._setDirty(true);
			}
		},
		_appendInExtDefectList:function(data,type){
			if(data && data.length>0){
				this.setExtBlockingStatus(data);
				for(var i=0;i<data.length;i++){
					if(!this.extERRelatedDefects.contains(data[i])){
						this.extAddedERRelatedDefects.add(data[i]);
						this._setHeaderStatus(data[i].id, type);
					}
					if(this.extRemovedERRelatedDefects.contains[data[i]]){
						this.extRemovedERRelatedDefects.remove(data[i]);
					}
				}
				this.updateDefectSection();
				this._setDirty(true);
			}
		},
		_setHeaderStatus: function(item,type){
			if (type == "new") {
				this._header.setStatus(Constants.getMessage("msgNewDefectAddedtoER", item), 
					ViewHeaderLayout.INFO, Constants.getMessage("msgDefectCanBeViewed"));
			}
			else {
				this._header.setStatus(Constants.getMessage("msgDefectAddedtoER", item), 
					ViewHeaderLayout.INFO, Constants.getMessage("msgDefectCanBeViewed"));
			}	
		},
		_getSortedDefectList:function(result)
        {
			this.defectList = [];
			this.defectIdList = [];
			if (result.defects) {
				for (var i = 0; i < result.defects.length; i++) {
					if(result.defects[i].workItem){
						var defect = result.defects[i].workItem;
						var defectId = "";
						var defectStatus = Constants.getMessage("labelUnknown");
						var defectStatusId = 1;
						var defectSummary = "";
						if(defect.attributes){
							for (var j = 0; j < defect.attributes.length; j++) {
								switch (defect.attributes[j].key) {
									case "id":
										defectId = defect.attributes[j].value.id;
										break;
									case "summary":
										defectSummary = defect.attributes[j].value.content;
										break;
									case "internalState":
										defectStatus = defect.attributes[j].value.label;
										defectStatusId = defect.attributes[j].value.id;
										break;
								}
							}
							this.defectList.push({id: defectId,status: defectStatus,summary: defectSummary,statusId:defectStatusId});
							this.defectIdList.push(defectId);
						}
					}else if(result.defects[i].id){
						this.defectList.push(result.defects[i]);
						this.defectIdList.push(result.defects[i].id);
					}
				}
				this.defectList.sort(function(defect1, defect2){
					var id1 = parseInt(defect1.id, 10);
					var id2 = parseInt(defect2.id, 10);
					return id2 - id1; //if id2 is greater than id1 return positive 
				});
			}				
        },
		createDefectTable: function(){
			if(this.result)
				this._getSortedDefectList(this.result);	
			if(this.ewi && this.defectList.length>0)
				this.setBlockingStatus(this.defectList);
			if(this.defectTable){
				this.updateDefectSection();
			}else{
				var defectOrigin = DEFECT_ORIGIN_1;
				if(this.editable){
					defectOrigin = DEFECT_ORIGIN_2;
				}
				this.defectTable = new DefectTableView({defects: this.defectList, parentEditor: this, defectOrigin: defectOrigin});
				var defectParams ={
					title: Constants.getMessage("labelDefects"),
					summary: this.defectTable.domNode,
					helpContextId: "rqm_execution_defects_help.html"
				}
				
				var defectTableSection = this._createCollapsibleSection(defectParams);
				dojox.data.dom.removeChildren(this._defectTable);
				this._defectTable.appendChild(defectTableSection.domNode);
			}
			ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
				if((!this.isExtSaved) && currentProvider!= null){
					// Get the external rtc defects of ExecutionResult			
					if(this.resultItemId && this.resultItemId!= "null" ){
						this._getExtResultRelatedDefects(this.resultItemId, true, CmIntegrationClient.RESULT_RELATEDTO_DEFECT );	
					}		
				}
			}));
		},
		
		updateDefectSection: function(){
			if(this.defectTable){
				var extChangedERRelatedDefects = this.extERRelatedDefects.clone();
				extChangedERRelatedDefects.addRange(this.extAddedERRelatedDefects.toArray());
				dojo.forEach(this.extRemovedERRelatedDefects.toArray(), function(defect){
					extChangedERRelatedDefects.remove(defect);
				});
				var allDefects = extChangedERRelatedDefects.toArray();
				this.defectTable.setContent(allDefects.concat(this.defectList));
			}
		},
		_getExtResultRelatedDefects:function(itemId, isResultRelated, linkType){
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociatedDefects"), dojo.hitch(this, function(monitor){
				
			var workItemIdentification = { 
					linkType: linkType,
					isExecutionResultRelated: isResultRelated, 
					itemIdOrUriArray: [itemId] 
			};
			CmIntegrationClient.postAssociatedWorkItems(workItemIdentification, 
				dojo.hitch(this, function(status, response) {
						if (status.isOK()) {
							dojo.forEach(response, dojo.hitch(this, function(workItem) {
								this._updateExternalDraftItem({id: workItem.id,
										summary: Utility._restoreTags(workItem.summary),
										defectItemUri: workItem.uri
								});					
							}));
							// Get the external blocking defects of ewi
							if(this.ewi.itemId && this.ewi.itemId != "null"){
								this._getExtEwiBlockingDefects(this.ewi.itemId, false, CmIntegrationClient.EWI_BLOCKING_DEFECT, monitor );					
							} else {
								monitor.done();
							}	
							if(this.extERRelatedDefects.count > 0){
								this.setExtBlockingStatus(this.extERRelatedDefects.toArray());
								this.updateDefectSection();
							}
						} else if (status.getSeverity() != Status.CANCEL) {
			                status.log();
							alert(Constants.getMessage("labelNoAssociatedWorkItems", status.getMessage()));
			            }
				}));
			}));
		},
		_getExtEwiBlockingDefects:function(itemId, isResultRelated, linkType, monitor){
			var workItemIdentification = { 
					linkType: linkType,
					isExecutionResultRelated: isResultRelated, 
					itemIdOrUriArray: [itemId] 
			};
			CmIntegrationClient.postAssociatedWorkItems(workItemIdentification, 
			dojo.hitch(this, function(status, response) {
					if (status.isOK()) {
						dojo.forEach(response, dojo.hitch(this, function(workItem) {						
							this.extBlockingDefects.add({id: workItem.id,
								summary: Utility._restoreTags(workItem.summary),
								defectItemUri: workItem.uri,
								isBlocking: true
							});
						}));
						if(this.ewi.itemId && this.ewi.itemId != "null"){
							this._getExtEwiRelatedDefects(this.ewi.itemId, false, CmIntegrationClient.RESULT_RELATEDTO_DEFECT, monitor);						
						}else {
							monitor.done();
						}
						if(this.extERRelatedDefects.count > 0){
							this.setExtBlockingStatus(this.extERRelatedDefects.toArray());
							this.updateDefectSection();
						}
					} else if (status.getSeverity() != Status.CANCEL) {
		                status.log();
						alert(Constants.getMessage("labelNoAssociatedWorkItems", status.getMessage()));
		            }
			}));
		},
		_getExtEwiRelatedDefects:function(itemId, isResultRelated, linkType, monitor){
			var self = this;
			if(itemId == null) return;
			var _draftUriFilter = [];
		    var stepProperties = this._typeSpecificSectionWidget.stepProperties;
			if(stepProperties && stepProperties.length>0){
				for(var i = 0; i < stepProperties.length; i++){
					if(stepProperties[i] && stepProperties[i].length>0){
						for(var j = 0; j < stepProperties[i].length; j++){
							if(stepProperties[i][j].propertyType == "rtcdefectView")
								_draftUriFilter.push(stepProperties[i][j].propertyValue) ;
						}
					}
				}
			}
			var workItemIdentification = { 
					linkType: linkType,
					isExecutionResultRelated: isResultRelated, 
					itemIdOrUriArray: [itemId] 
			};
			CmIntegrationClient.postAssociatedWorkItems(workItemIdentification, 
				dojo.hitch(this, function(status, response) {
					try{
						if (status.isOK()) {
							dojo.forEach(response, dojo.hitch(this, function(workItem) {							
								for(var i = 0; i < _draftUriFilter.length; i++){ 
									if (_draftUriFilter[i].indexOf(workItem.uri) == 0){	
										self._updateExternalDraftItem({id: workItem.id,
												summary: Utility._restoreTags(workItem.summary),
												status: workItem.status,
												defectItemUri: workItem.uri
										});
									}
								}	
							}));
//							if(this.extERRelatedDefects.length > 0){
								this.setExtBlockingStatus(this.extERRelatedDefects.toArray());
								this.updateDefectSection();
//							}
						} else if (status.getSeverity() != Status.CANCEL) {
			                status.log();
							alert(Constants.getMessage("labelNoAssociatedWorkItems", status.getMessage()));
			            }
					} finally {
						monitor.done();
					}				
				}));
		},
		
		setBlockingStatus:function(defectList){
			var blockingDefects = this.ewi.defects;
			var blockedDefectIds = [];
			if(blockingDefects && blockingDefects.length>0){
				for(var i=0;i<blockingDefects.length;i++){
					if(blockingDefects[i].workItem){
						var defectAttr = blockingDefects[i].workItem.attributes;
						var defectId = null;
						var defectIsOpen = false;
						for(var j=0;j<defectAttr.length;j++){
							if(defectAttr[j].key == "id"){
								defectId = defectAttr[j].value.id;
								//if we already figured that the defect isnt closed push it in the blockedDefectIds list and break
								if(defectIsOpen){
									blockedDefectIds.push(defectId);
									break;
								}
							}
							if(defectAttr[j].key == "internalState" && defectAttr[j].value.id != 5 ){ //id 5 corresponds to Closed
								//if we already got the defectID push it in the blockedDefectIds list and break
								if(defectId){
									blockedDefectIds.push(defectId);
									break;
								}else{
									defectIsOpen = true;
								}
							}
						}
					}else{
						if(blockingDefects[i].isBlocking)
							blockedDefectIds.push(blockingDefects[i].id);
					}
				}
			}
			if(blockedDefectIds.length>0){
				for(var k=0;k<blockedDefectIds.length;k++){
					for(var l=0;l<defectList.length;l++){
						if(defectList[l].id == blockedDefectIds[k])
							defectList[l].isBlocking = true;
					}
				}
			}
		},
		setExtBlockingStatus: function(extDefectList){
			this.extBlockingDefects.forEach(function(defect){
					for(var i = 0; i < extDefectList.length; i++){
						if(extDefectList[i].id == defect.id)
							extDefectList[i].isBlocking = true;
					}
			}, this);
		},
        _loadError: function(e) {
            com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(Constants.getMessage("labelExeResult"), e.message);
        },
		
		getEWI: function(){
			return this.ewi;
		},
		
		_updateExternalDraftItem: function(defect){
			var location = -1;
			this.extERRelatedDefects.forEach(function(item){
				if(item.id == defect.id){
					location =  this.extERRelatedDefects.indexOf(item);
				}
			}, this);
			if(!(location == -1)){
				this.extERRelatedDefects.setByIndex(location, defect);
//				this._setDirty(true);
			}else{
				this.extERRelatedDefects.add({id: defect.id,
									summary: defect.summary,
//									status: defect.status,
									defectItemUri: defect.defectItemUri
				});
			}
			this.updateDefectSection();
		},
		
		removeExternalDraftItem: function(defects){			
			dojo.forEach(defects, dojo.hitch(this, function(defect){
				if(this.extAddedERRelatedDefects.contains(defect)){
					this.extAddedERRelatedDefects.remove(defect);
				}
				if(this.extERRelatedDefects.contains(defect) && !this.extRemovedERRelatedDefects.contains(defect)){
					this.extRemovedERRelatedDefects.add(defect);
				}
				this.extBlockingChangedDefects.remove(defect);
				defect.isBlocking = false;
				this.extBlockingChangedDefects.add(defect);
			}));
			this.updateDefectSection();
			if(this._typeSpecificSectionWidget && this._typeSpecificSectionWidget.deleteDefect){
				this._typeSpecificSectionWidget._deleteDefect(defects);
			}
			this._setDirty(true);
		},
		
		_error: function(errorObj) {
			console.error("Error: (message: '" + errorObj.message + "') from Execution Log Body#_error");
		}
	}
);

})();		
